using System;
using System.Threading;

namespace WritingADelegate
{
	public delegate void StockQuoteDelegate(double amount);
	public class StockQuote
	{
		private const int max = 1000;
		private double price = 0;
		private double high = 0;
		private double low = max;

		public StockQuoteDelegate highDelegate = null;
		public StockQuoteDelegate lowDelegate = null;

		private void newHighReached(double amount)
		{// one way to invoke the handlers
			Object[] args = new Object[1];
			args[0] = amount;
			highDelegate.DynamicInvoke(args);
		}

		private void newLowReached(double amount)
		{// another way of achieving the same result
			lowDelegate(amount);
		}

		private void generatePrice()
		{
			Random rand = new Random();
			while(true)
			{
				price = rand.NextDouble() * max;
				if (price > high) 
				{
					high = price;
					newHighReached(price);
				}

				if (price < low) 
				{
					low = price;
					newLowReached(price);
				}

				Thread.Sleep(1000);
			}
		}

		public StockQuote()
		{
			new Thread(new ThreadStart(generatePrice)).Start();
		}
	}
}
